;----------------------------------------------------------------------------------------
; Public Library  
;
; Copyright 2007 Veria Kalantary - Ideas of East Company
; http://www.IdeasofEast.com; http://www.ioe.co.ir
;
;----------------------------------------------------------------------------------------

method0Proto	typedef proto :DWORD
method1Proto    typedef proto :DWORD
method2Proto    typedef proto :DWORD, :DWORD
method3Proto    typedef proto :DWORD, :DWORD, :DWORD
method4Proto    typedef proto :DWORD, :DWORD, :DWORD, :DWORD
method5Proto    typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
method6Proto    typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
method7Proto    typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
method8Proto    typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
method9Proto    typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
method10Proto   typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
method11Proto   typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD
method12Proto   typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD
method13Proto   typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD
method14Proto   typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD
method15Proto   typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
method16Proto   typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD
method17Proto   typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD
method18Proto   typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD
method19Proto   typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD
method20Proto   typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD

method0         typedef ptr method0Proto
method1         typedef ptr method1Proto
method2         typedef ptr method2Proto
method3         typedef ptr method3Proto
method4         typedef ptr method4Proto
method5         typedef ptr method5Proto
method6         typedef ptr method6Proto
method7         typedef ptr method7Proto
method8         typedef ptr method8Proto
method9         typedef ptr method9Proto
method10        typedef ptr method10Proto
method11        typedef ptr method11Proto
method12        typedef ptr method12Proto
method13        typedef ptr method13Proto
method14        typedef ptr method14Proto
method15        typedef ptr method15Proto
method16        typedef ptr method16Proto
method17        typedef ptr method17Proto
method18        typedef ptr method18Proto
method19        typedef ptr method19Proto
method20        typedef ptr method20Proto

memcpy 				proto :DWORD, :DWORD, :DWORD
memset 				proto :DWORD, :BYTE, :DWORD 
ShowErrorMessage 	proto :LPCSTR
CompareStructVar 	proto :DWORD, :DWORD, :DWORD
StrToBstr 			proto :LPCSTR
BstrToStr 			proto :BSTR
FreeBstr 			proto :DWORD 
BstrStrCmp 			proto :BSTR, :LPCSTR
SetLength 			proto :DWORD, :DWORD, :DWORD
StrPos 				proto :LPCSTR, :LPCSTR
DeleteStr 			proto :LPCSTR, :DWORD, :DWORD
CopyStr 			proto :LPCSTR, :LPCSTR, :DWORD, :DWORD

PVARIANT		typedef ptr VARIANT

.data?
    ErrorMessage        db          MAX_PATH dup(?)
    seh      			dd 			6 dup (?)

.code

memcpy PROC uses esi edi ecx ptrSrc:DWORD, ptrDest:DWORD, dwSize:DWORD     
	 mov  ecx, dwSize 
     mov  esi, ptrSrc       
     mov  edi, ptrDest
     cld
     rep  movsb
     ret
memcpy ENDP

memset PROC uses edi ecx pMem:DWORD, dwVal:BYTE, dwSize:DWORD
    mov edi, pMem
    mov al, dwVal
    mov ecx, dwSize
    cld
    rep stosb 
    ret
memset ENDP

ShowErrorMessage PROC uses ebx hDlg:LPCSTR
    invoke GetLastError	
	push eax	
	pop ebx
	invoke FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM, NULL, ebx, eax, OFFSET ErrorMessage, MAX_PATH, NULL
	invoke MessageBox, NULL, OFFSET ErrorMessage, NULL, MB_OK
    ret
ShowErrorMessage ENDP

CompareStructVar PROC uses esi edi ecx pStructVarA: DWORD, pStructVarB: DWORD, dwSize: DWORD		
	mov esi, pStructVarA
	mov edi, pStructVarB
	mov ecx, dwSize
@@:
	mov eax, [esi]
	add esi, 4
	sub eax, [edi]
	jne @F
	add edi, 4
	sub ecx, 4	
	cmp ecx, 0
	jne @B	
	xor eax, eax
@@:
	ret
CompareStructVar endp

StrToBstr proc lpStrBuff: LPCSTR
	LOCAL bstr: DWORD
	LOCAL dwBuffSize: DWORD
	
	invoke lstrlen, lpStrBuff
	.if eax != 0
		shl eax, 1
		mov dwBuffSize, eax
		inc eax			
		invoke SysAllocStringByteLen, 0, eax
		mov bstr, eax
		Invoke MultiByteToWideChar, CP_ACP, 0, lpStrBuff, -1, bstr, dwBuffSize
		mov eax, bstr		
	.endif					
	ret
StrToBstr endp

BstrToStr proc bs: BSTR  
	LOCAL pszBuff: DWORD
	LOCAL lenBuff: DWORD
		
	invoke WideCharToMultiByte, CP_ACP, 0, bs, -1, pszBuff, 0, NULL, NULL
	.if eax > 0
		mov lenBuff, eax
		invoke GlobalAlloc, GPTR, eax				
		mov pszBuff, eax
		invoke WideCharToMultiByte, CP_ACP, 0, bs, -1, pszBuff, lenBuff, NULL, NULL
		mov eax, pszBuff
	.endif
	ret			
BstrToStr endp

FreeBstr proc pBstr:DWORD
	mov eax, pBstr
	mov eax, [eax]
	invoke SysFreeString, eax
	mov eax, pBstr		  
	m2m [eax], NULL
	ret
FreeBstr endp

BstrStrCmp proc uses ebx pbstr1:BSTR, lpstr:LPCSTR
	LOCAL bstr2: BSTR
	invoke StrToBstr, lpstr
    mov bstr2, eax   
    mov ebx, pbstr1
    invoke lstrcmpW, dword ptr [ebx], bstr2	
    push eax
    invoke FreeBstr, pbstr1
    invoke FreeBstr, addr bstr2
    pop eax	
	ret
BstrStrCmp endp 

SetLength proc uses ebx ppBuff:DWORD, dwElementSize:DWORD, dwCount:DWORD
	LOCAL hHeap: DWORD
	LOCAL dwSize: DWORD
	LOCAL pBuff: DWORD
	
	invoke GetProcessHeap
	mov hHeap, eax
	mov ebx, ppBuff
	m2m pBuff, dword ptr [ebx]	
	.if dwCount == 0 
		invoke HeapFree, hHeap, NULL, pBuff 		
	.else
		mov eax, dwCount
		mul dwElementSize
		mov dwSize, eax 		
		.if pBuff == NULL
			invoke HeapAlloc, hHeap, HEAP_ZERO_MEMORY, dwSize
		.else
			invoke HeapReAlloc, hHeap, HEAP_ZERO_MEMORY, pBuff, dwSize	
		.endif		
		mov dword ptr [ebx], eax 
	.endif 	
	ret
SetLength endp 

PosStr proc uses ebx ecx edx esi edi pStr:LPCSTR, pSubStr:LPCSTR
	LOCAL dwStrLen: DWORD
	LOCAL dwSubStrLen: DWORD
	
	invoke lstrlen, pStr
	mov dwStrLen, eax
	invoke lstrlen, pSubStr
	mov dwSubStrLen, eax
	xor ecx, ecx	
	mov esi, pStr
	dec esi	
	dec esi
@@Next:	
	inc esi
	inc ecx	
	.if ecx <= dwStrLen
		xor edx, edx
		mov edi, pSubStr
		dec edi		
	@@Scan:		
		inc edx
		.if edx <= dwSubStrLen			
			mov al, [esi + edx]			
			mov bl, [edi + edx] 			 
			.if al == bl
				.if edx == dwSubStrLen
					mov eax, ecx
					jmp @@Exit
				.else
					jmp @@Scan
				.endif				
			.else
				jmp @@Next		
			.endif
		.else 
			jmp @@Next			
		.endif		
	.else
		xor eax, eax	
	.endif	
@@Exit:	
	ret
PosStr endp

DeleteStr proc uses ebx esi edi pStr:LPCSTR, dwIndex:DWORD, dwCount:DWORD
	LOCAL dwStrLen: DWORD	
	
	invoke lstrlen, pStr
	mov dwStrLen, eax	
	mov ebx, dwIndex
	add ebx, dwCount
	dec ebx
	.if (dwIndex <= eax) && (dwIndex > 0) && (ebx <= eax)
		mov esi, pStr		
		add esi, dwIndex
		dec esi
		mov edi, esi
		add edi, dwCount
		sub dwStrLen, ebx
	@@:	
		.if dwStrLen > 0
			mov al, [edi]
			mov [esi], al
			inc esi
			inc edi
			dec dwStrLen
			jmp @B	
		.endif 	
		mov byte ptr [esi], 0
		mov eax, pStr
	.else
		mov eax, 0	
	.endif
	ret
DeleteStr endp

CopyStr proc uses ebx esi edi pDestStr:LPCSTR, pSrcStr:LPCSTR, dwIndex:DWORD, dwCount:DWORD
	LOCAL dwSrcStrLen: DWORD	
	
	invoke lstrlen, pSrcStr		
	mov ebx, dwIndex
	add ebx, dwCount
	dec ebx
	.if (dwIndex <= eax) && (dwIndex > 0) && (ebx <= eax)
		mov esi, pSrcStr		
		add esi, dwIndex
		dec esi
		mov edi, pDestStr		
		mov ebx, dwCount
	@@:	
		.if ebx > 0
			mov al, [esi]
			mov [edi], al
			inc esi
			inc edi
			dec ebx
			jmp @B	
		.endif 	
		mov byte ptr [edi], 0
		mov eax, pDestStr
	.else
		mov eax, 0	
	.endif
	ret
CopyStr endp 